#!/bin/bash

echo "EM12-setup -- $* --" | systemd-cat -p info -t em12-setup

function send_at_command {
    exec 99</dev/ttyUSB3
    cat <&99 > /tmp/ttyDump &
    PID=$!
    echo "$1" > /dev/ttyUSB3
    sleep 0.2s
    kill -13 $PID
    exec 99<&-
    out=$(cat /tmp/ttyDump)
    rm /tmp/ttyDump
    echo $out
}

check_usb=$(send_at_command 'AT')
if [[ ! $check_usb == *"OK"* ]]; then
    exit 1
fi

check_qmi_settings=$(send_at_command 'AT+QCFG="usbnet"')
if [[  $check_qmi_settings == *'"usbnet",0'* ]]; then
    echo "Modem is already in QMI mode." | systemd-cat -p info -t em12-setup
elif [[ $check_qmi_settings == *'"usbnet",2'* ]]; then
    echo "Setting modem to QMI mode." | systemd-cat -p info -t em12-setup
    set_qmi_settings=$(send_at_command 'AT+QCFG="usbnet",0')
    sleep 1
fi

echo 'Y' > /sys/class/net/$1/qmi/raw_ip
/opt/lte-process.sh add $1

exit 0