#!/bin/bash
exec 1> >(systemd-cat -p info -t modem-preinit) 2>&1
set -o xtrace
set -o nounset
set -o pipefail
set -o errexit
#
echo "Modem-preinit -- $* --"
#
#check for ID 1199:9071 Sierra Wireless, Inc.
has_sierra=$(lsusb | grep "1199:9071")
#
if [ -n "${has_sierra}" ]; then
  #program QMI mode
  if [ ! -e /dev/ttyUSB2 ]; then
    #try to give some time for drivers to be loaded
    sleep 5s
  fi
  if [ -e /dev/ttyUSB2 ]; then
    stty -F /dev/ttyUSB2 9600 cs8 cread clocal || true
    chat -v -f /opt/chat.script < /dev/ttyUSB2 > /dev/ttyUSB2 && sleep 5s
  fi
fi
#
exit 0
